<template>
  <vx-card no-shadow>
    <!-- Img Row -->
    <div class="flex flex-wrap items-center mb-base">
      <vs-avatar :src="user.image" size="70px" class="mr-4 mb-4" />
      <div>
        <vs-button class="mr-4 sm:mb-0 mb-2">Upload photo</vs-button>
        <vs-button type="border" color="danger">Remove</vs-button>
        <p class="text-sm mt-2">Allowed JPG, GIF or PNG. Max size of 800kB</p>
      </div>
    </div>

    <!-- Info -->
    <vs-input
      v-validate="'required'"
      class="w-full mb-base"
      data-vv-validate-on="blur"
      label-placeholder="Name"
      name="name"
      v-model="form.name"
    ></vs-input>
    <span class="text-danger text-sm">{{ errors.first("name") }}</span>
    <vs-input
      v-validate="'required'"
      class="w-full"
      label-placeholder="Email"
      name="email"
      data-vv-validate-on="blur"
      v-model="form.email"
    ></vs-input>
    <span class="text-danger text-sm">{{ errors.first("email") }}</span>

    <!-- Save & Reset Button -->
    <div class="flex flex-wrap items-center justify-end">
      <vs-button class="ml-auto mt-2" @click="updateUser()"
        >Save Changes</vs-button
      >
      <vs-button class="ml-4 mt-2" type="border" color="warning"
        >Reset</vs-button
      >
    </div>
  </vx-card>
</template>

<script>
import { mapActions, mapGetters } from "vuex";

export default {
  data() {
    return {
      form: {
        name: "",
        email: ""
      }
    };
  },
  computed: {
    ...mapGetters({
      user: "auth/user",
      success_message: "user/message",
      error_message: "user/error_messages"
    })
  },
  mounted() {
    this.user;
    this.userDetails();
  },

  methods: {
    ...mapActions({
      update: "user/update"
    }),

    userDetails() {
      this.form = this.user;
    },

    updateUser() {
      this.$validator.validateAll().then(result => {
        if (result) {
          this.update(this.form).then(reponse => {
            this.user;
            if (this.error_message) {
              this.$vs.notify({
                color: "danger",
                title: "Failed",
                text: this.error_message
              });
            } else {
              this.$vs.notify({
                color: "success",
                title: "Success",
                text: this.success_message
              });
            }
          });
        } else {
          this.$vs.notify({
            color: "danger",
            title: "Failed",
            text: "Invalid Inputs"
          });
        }
      });
    }
  }
};
</script>
